isc.defineClass("EditSavedSearchWindow", Window);

isc.EditSavedSearchWindow.addProperties({
	itemDataSource: null,
	dataSource: null,
	record: null,
	updateSavedSearchCallback: null,
	title: "New search",
	autoCenter: true,
	isModal: true,
	autoSize: true,
	showModalMask: true,
	dismissOnEscape:true,
	showMinimizeButton:false,
    show: function () {
        this._form.clearValues();
        this._filter.clearCriteria();

        if (this.record != null) {
			this._form.setValue("id", this.record.id);
        	this._form.setValue("name", this.record.name);

			var criteria = isc.JSON.decode(this.record.criteria);
        	this._filter.setCriteria(criteria);
		}
		
    	this.Super("show", arguments);
    },
    initWidget: function () {
    	this.Super("initWidget", arguments);
    	this.addItems(this._createMembers());
    },
    _createMembers: function () {
		var _this = this;

    	return [
    		this._form = isc.DynamicForm.create({
    			width: 700,
    			margin: 5,
    			useAllDataSourceFields: true,
    			dataSource: this.dataSource,
    			fields: [
					{
						editorType: "HeaderItem",
						defaultValue: "New search"
					},
					{
						editorType: "TextItem",
						name: "name"
					},
					{
						editorType: "CanvasItem",
						name: "criteriaFilter",
						title: "Criteria",
						createCanvas : function () {
							return _this._filter = isc.FilterBuilder.create({
								dataSource: _this.itemDataSource								
							});
						}
					},
					{
						editorType: "ButtonItem",
						name: "submit",
						title: "Search",
						click: function () {
							_this._onSubmit();
						}
					}
				]
    		})
    	];
    },
    _onSubmit: function () {
    	var criteriaValue = isc.JSON.encode(this._filter.getCriteria(), {
    		dateFormat: "dateConstructor"
    	});
    	this._form.setValue("criteria", criteriaValue);

    	this._form.setValue("type", this.itemDataSource.ID);

    	var _this = this;
    	this._form.submit(function (dsResponse, data, dsRequest) {
			_this._onSubmitted(dsResponse.data[0]);
        });
    },
    _onSubmitted: function (record) {
    	this.record = record;
    	if (this.updateSavedSearchCallback != null) {
            this.updateSavedSearchCallback(record);
        }
        this.hide();
    }
});
